Index: trunk/XTIDE_Universal_BIOS/Src/StringsCompressed.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/StringsCompressed.asm	(revision 391)
+++ trunk/XTIDE_Universal_BIOS/Src/StringsCompressed.asm	(revision 392)
@@ -26,5 +26,5 @@
 ; GNU General Public License for more details.
 ; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html		
-;				
+;		
 
 %ifdef MODULE_STRINGS_COMPRESSED_PRECOMPRESS
@@ -128,7 +128,7 @@
 
 ; Boot loader strings
-g_szTryToBoot:			; db	"Booting from %s %x",ANGLE_QUOTE_RIGHT,"%x",LF,CR,NULL
-              			; db	 42h,  6fh,  6fh,  74h,  69h,  6eh,  67h,  20h,  66h,  72h,  6fh,  6dh,  20h,  25h,  73h,  20h,  25h,  78h, 0afh,  25h,  78h,  0ah,  0dh,  00h    ; uncompressed
-              			  db	 48h,  75h,  75h,  7ah,  6fh,  74h, 0edh,  6ch,  78h,  75h, 0f3h,  3eh,  20h,  39h,  24h,  39h,  1bh                                              ; compressed
+g_szTryToBoot:			; db	"Booting %c",ANGLE_QUOTE_RIGHT,"%c",LF,CR,NULL
+              			; db	 42h,  6fh,  6fh,  74h,  69h,  6eh,  67h,  20h,  25h,  63h, 0afh,  25h,  63h,  0ah,  0dh,  00h    ; uncompressed
+              			  db	 48h,  75h,  75h,  7ah,  6fh,  74h, 0edh,  35h,  24h,  35h,  1bh                                  ; compressed
 
 g_szBootSectorNotFound:	; db	"Boot sector "
@@ -143,4 +143,5 @@
               			; db	 45h,  72h,  72h,  6fh,  72h,  20h,  25h,  78h,  21h,  0ah,  0dh,  00h    ; uncompressed
               			  db	 4bh,  78h,  78h,  75h, 0f8h,  39h,  25h,  1bh                            ; compressed
+
 
 
@@ -249,17 +250,25 @@
 
 ; Boot menu bottom of screen strings
-g_szFDD:		; db	"FDD     ",NULL
-        		; db	 46h,  44h,  44h,  20h,  20h,  20h,  20h,  20h,  00h    ; uncompressed
-        		  db	 4ch,  4ah, 0cah,  20h,  20h,  20h,  00h                ; compressed
-
-g_szHDD:		; db	"HDD     ",NULL
-        		; db	 48h,  44h,  44h,  20h,  20h,  20h,  20h,  20h,  00h    ; uncompressed
-        		  db	 4eh,  4ah, 0cah,  20h,  20h,  20h,  00h                ; compressed
-
-g_szRomBoot:	; db	"ROM Boot",NULL
-            	; db	 52h,  4fh,  4dh,  20h,  42h,  6fh,  6fh,  74h,  00h    ; uncompressed
-            	  db	 58h,  55h, 0d3h,  48h,  75h,  75h, 0bah                ; compressed
-
-g_szHotkey:		; db	"%A%c%c%A%s%A ",NULL
+g_szFDD:		; db	"FDD [%c]",NULL			; "FDD [A]"
+        		; db	 46h,  44h,  44h,  20h,  5bh,  25h,  63h,  5dh,  00h    ; uncompressed
+        		  db	 4ch,  4ah, 0cah,  61h,  35h, 0a3h                      ; compressed
+
+g_szHDD:		; db	"HDD [%c]",NULL			; "HDD [C]"
+        		; db	 48h,  44h,  44h,  20h,  5bh,  25h,  63h,  5dh,  00h    ; uncompressed
+        		  db	 4eh,  4ah, 0cah,  61h,  35h, 0a3h                      ; compressed
+
+g_szBootMenu:	; db	"%sMnu",NULL			; "BootMnu"
+             	; db	 25h,  73h,  4dh,  6eh,  75h,  00h    ; uncompressed
+             	  db	 3eh,  53h,  74h, 0bbh                ; compressed
+
+g_szRomBoot:	; db	"Rom%s",NULL			; "RomBoot"
+            	; db	 52h,  6fh,  6dh,  25h,  73h,  00h    ; uncompressed
+            	  db	 58h,  75h,  73h,  1eh                ; compressed
+
+g_szBoot:		; db	"Boot",NULL
+         		; db	 42h,  6fh,  6fh,  74h,  00h    ; uncompressed
+         		  db	 48h,  75h,  75h, 0bah          ; compressed
+
+g_szHotkey:		; db	"%A%c%c%A%s%A ",NULL	; "C»HDD [A] ", "F2BootMnu " or "F8RomBoot "
            		; db	 25h,  41h,  25h,  63h,  25h,  63h,  25h,  41h,  25h,  73h,  25h,  41h,  20h,  00h    ; uncompressed
            		  db	 3dh,  35h,  35h,  3dh,  3eh,  3dh,  00h                                              ; compressed
@@ -371,6 +380,4 @@
 ; End of StringsCompress.pl information
 ;
-;------------------------------------------------------------------------------------------
-
 ;;; end of input stream
 
@@ -455,5 +462,5 @@
 ;; translated usage stats
 ;; 33:1
-;; 32:31
+;; 32:22
 ;; 181:1
 ;; 53:2
@@ -481,10 +488,10 @@
 ;; 2-u:1
 ;; 5-u:2
-;; x:7
-;; s:12
+;; x:5
+;; s:13
 ;; 5-x:1
 ;; nl:8
 ;; 2-I:1
-;; c:5
+;; c:9
 ;; u:6
 ;; z:1
@@ -513,5 +520,5 @@
 ;; 77,M:4
 ;; 78,N:1
-;; 79,O:2
+;; 79,O:1
 ;; 80,P:2
 ;; 81,Q:1
@@ -525,7 +532,7 @@
 ;; 89,Y:
 ;; 90,Z:
-;; 91,[:
+;; 91,[:2
 ;; 92,\:
-;; 93,]:
+;; 93,]:2
 ;; 94,^:
 ;; 95,_:
@@ -536,5 +543,5 @@
 ;; 100,d:6
 ;; 101,e:15
-;; 102,f:2
+;; 102,f:1
 ;; 103,g:2
 ;; 104,h:
@@ -544,17 +551,17 @@
 ;; 108,l:5
 ;; 109,m:1
-;; 110,n:10
+;; 110,n:11
 ;; 111,o:17
 ;; 112,p:3
 ;; 113,q:
-;; 114,r:12
+;; 114,r:11
 ;; 115,s:7
 ;; 116,t:12
-;; 117,u:3
+;; 117,u:4
 ;; 118,v:3
 ;; 119,w:1
 ;; 120,x:
 ;; 121,y:2
-;; alphabet used count: 42
+;; alphabet used count: 44
 %endif ; STRINGSCOMPRESSED_TABLES
 
Index: trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/BootMenuInfo.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/BootMenuInfo.asm	(revision 392)
+++ trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/BootMenuInfo.asm	(revision 392)
@@ -0,0 +1,101 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	Functions for generating and accessing drive
+;					information to be displayed on boot menu.
+
+;
+; XTIDE Universal BIOS and Associated Tools 
+; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
+;
+; This program is free software; you can redistribute it and/or modify
+; it under the terms of the GNU General Public License as published by
+; the Free Software Foundation; either version 2 of the License, or
+; (at your option) any later version.
+; 
+; This program is distributed in the hope that it will be useful,
+; but WITHOUT ANY WARRANTY; without even the implied warranty of
+; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+; GNU General Public License for more details.
+; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html				
+;
+				
+; Section containing code
+SECTION .text
+
+;--------------------------------------------------------------------
+; Creates new BOOTMENUINFO struct for detected hard disk.
+;
+; BootMenuInfo_CreateForHardDisk
+;	Parameters:
+;		DL:		Drive number
+;		DS:DI:	Ptr to Disk Parameter Table
+;		ES:SI:	Ptr to 512-byte ATA information read from the drive
+;	Returns:
+;		ES:BX:	Ptr to BOOTMENUINFO (if successful)
+;	Corrupts registers:
+;		AX, BX, CX, DX, DI
+;--------------------------------------------------------------------
+BootMenuInfo_CreateForHardDisk:
+	call	BootMenuInfo_ConvertDPTtoBX			; ES:BX now points to new BOOTMENUINFO
+
+	; Store Drive Name
+	push	ds									; Preserve RAMVARS
+	push	si
+
+	push	es									; ES copied to DS
+	pop		ds
+
+	add		si, BYTE ATA1.strModel				; DS:SI now points drive name
+	lea		di, [bx+BOOTMENUINFO.szDrvName]		; ES:DI now points to name destination
+	mov		cx, MAX_HARD_DISK_NAME_LENGTH / 2	; Max number of WORDs allowed
+.CopyNextWord:
+	lodsw
+	xchg	al, ah								; Change endianness
+	stosw
+	loop	.CopyNextWord
+	xor		ax, ax								; Zero AX and clear CF
+	stosw										; Terminate with NULL
+
+	pop		si
+	pop		ds
+		
+	ret
+
+
+;--------------------------------------------------------------------
+; BootMenuInfo_GetTotalSectorCount
+;	Parameters:
+;		DS:DI:		DPT Pointer
+;	Returns:
+;		BX:DX:AX:	48-bit sector count
+;	Corrupts registers:
+;		CX
+;--------------------------------------------------------------------
+%ifdef MODULE_BOOT_MENU
+BootMenuInfo_GetTotalSectorCount:
+	test	BYTE [di+DPT.bFlagsLow], FLG_DRVNHEAD_LBA
+	jnz		SHORT .ReturnFullCapacity
+	jmp		AH15h_GetSectorCountToBXDXAX
+.ReturnFullCapacity:
+	jmp		AccessDPT_GetLbaSectorCountToBXDXAX
+%endif
+
+
+;--------------------------------------------------------------------
+; Returns offset to BOOTMENUINFO based on DPT pointer.
+;
+; BootMenuInfo_ConvertDPTtoBX
+;	Parameters:
+;		DS:DI:	DPT Pointer
+;	Returns:
+;		BX:		Offset to BOOTMENUINFO struct
+;	Corrupts registers:
+;		AX
+;--------------------------------------------------------------------
+BootMenuInfo_ConvertDPTtoBX:
+	mov		ax, di
+	sub		ax, BYTE RAMVARS_size					; subtract off base of DPTs
+	mov		bl, DPT_BOOTMENUINFO_SIZE_MULTIPLIER	; BOOTMENUINFO's are a whole number multiple of DPT size
+	mul		bl								
+	add		ax, BOOTVARS.rgBootNfo					; add base of BOOTMENUINFO
+	xchg	ax, bx
+	ret	
Index: trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/BootVars.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/BootVars.asm	(revision 392)
+++ trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/BootVars.asm	(revision 392)
@@ -0,0 +1,60 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	Functions for accessings BOOTVARS.
+
+;
+; XTIDE Universal BIOS and Associated Tools 
+; Copyright (C) 2009-2010 by Tomi Tilli, 2011-2012 by XTIDE Universal BIOS Team.
+;
+; This program is free software; you can redistribute it and/or modify
+; it under the terms of the GNU General Public License as published by
+; the Free Software Foundation; either version 2 of the License, or
+; (at your option) any later version.
+; 
+; This program is distributed in the hope that it will be useful,
+; but WITHOUT ANY WARRANTY; without even the implied warranty of
+; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+; GNU General Public License for more details.		
+; Visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+;		
+
+; Section containing code
+SECTION .text
+
+;--------------------------------------------------------------------
+; BootVars_Initialize
+;	Parameters:
+;		DS:		RAMVARS Segment
+;		ES:		BDA Segment
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, CX, DX, DI
+;--------------------------------------------------------------------
+BootVars_Initialize:
+	; Clear to zero
+	mov		al, BOOTMENUINFO_size
+	mul		BYTE [cs:ROMVARS.bIdeCnt]
+	mov		di, BOOTVARS.hotkeyVars	; We must not initialize anything before this!
+	add		ax, BOOTVARS_size
+	sub		ax, di
+	xchg	cx, ax
+	call	Memory_ZeroESDIwithSizeInCX
+
+	; Store default drives to boot from
+	mov		di, BOOTVARS.hotkeyVars+HOTKEYVARS.wHddAndFddLetters
+	call	HotkeyBar_GetLetterForFirstHardDriveToAX
+	mov		ah, DEFAULT_FLOPPY_DRIVE_LETTER
+	mov		[es:di], ax
+
+	; Check if boot drive is overridden in ROMVARs
+	mov		al, [cs:ROMVARS.bBootDrv]
+	test	al, al
+	js		SHORT .StoreUserHardDiskToBootFrom
+	inc		di
+	jmp		SHORT .AddToDefaultDrive
+
+.StoreUserHardDiskToBootFrom:
+	sub		al, 80h					; Clear HD bit
+.AddToDefaultDrive:
+	add		[es:di], al
+	ret
Index: trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/RamVars.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/RamVars.asm	(revision 391)
+++ trunk/XTIDE_Universal_BIOS/Src/VariablesAndDPTs/RamVars.asm	(revision 392)
@@ -146,5 +146,5 @@
 ;		CX
 ;--------------------------------------------------------------------
-ALIGN JUMP_ALIGN
+%ifdef MODULE_BOOT_MENU
 RamVars_GetHardDiskCountFromBDAtoAX:
 	call	RamVars_GetCountOfKnownDrivesToAX
@@ -155,4 +155,6 @@
 	pop		ds
 	ret
+%endif
+
 
 ;--------------------------------------------------------------------
Index: trunk/XTIDE_Universal_BIOS/makefile
===================================================================
--- trunk/XTIDE_Universal_BIOS/makefile	(revision 391)
+++ trunk/XTIDE_Universal_BIOS/makefile	(revision 392)
@@ -54,9 +54,9 @@
 HEADERS += Inc/Controllers/
 HEADERS += Src/
-HEADERS += Src/Boot/
 HEADERS += Src/Handlers/
 HEADERS += Src/Handlers/Int13h/
 HEADERS += Src/Handlers/Int13h/EBIOS/
 HEADERS += Src/Handlers/Int13h/Tools/
+HEADERS += Src/Handlers/Int19h/
 HEADERS += Src/Device/
 HEADERS += Src/Device/IDE/
@@ -64,4 +64,7 @@
 HEADERS += Src/Device/Serial/
 HEADERS += Src/Initialization/
+HEADERS += Src/Initialization/AdvancedAta/
+HEADERS += Src/Menus/
+HEADERS += Src/Menus/BootMenu/
 HEADERS += Src/Libraries/
 HEADERS += Src/VariablesAndDPTs/
@@ -86,16 +89,16 @@
 # Assembler preprocessor defines.                               #
 #################################################################
-DEFINES_COMMON = MODULE_BOOT_MENU MODULE_EBIOS MODULE_STRINGS_COMPRESSED
+DEFINES_COMMON = MODULE_STRINGS_COMPRESSED MODULE_EBIOS
 
 DEFINES_XT = ELIMINATE_CGA_SNOW MODULE_SERIAL MODULE_SERIAL_FLOPPY
-DEFINES_XTPLUS = ELIMINATE_CGA_SNOW USE_186 MODULE_SERIAL MODULE_SERIAL_FLOPPY
-DEFINES_AT = USE_286 USE_AT MODULE_SERIAL MODULE_SERIAL_FLOPPY
-
-DEFINES_XT_LARGE = $(DEFINES_XT) MODULE_JRIDE MODULE_ADVANCED_ATA
-DEFINES_XTPLUS_LARGE = $(DEFINES_XTPLUS) MODULE_JRIDE MODULE_ADVANCED_ATA
-DEFINES_AT_LARGE = $(DEFINES_AT) MODULE_JRIDE MODULE_ADVANCED_ATA
+DEFINES_XTPLUS = USE_186 ELIMINATE_CGA_SNOW MODULE_SERIAL MODULE_SERIAL_FLOPPY
+DEFINES_AT = USE_AT USE_286 MODULE_SERIAL MODULE_SERIAL_FLOPPY MODULE_ADVANCED_ATA
+
+DEFINES_XT_LARGE = $(DEFINES_XT) MODULE_BOOT_MENU MODULE_JRIDE MODULE_ADVANCED_ATA
+DEFINES_XTPLUS_LARGE = $(DEFINES_XTPLUS) MODULE_BOOT_MENU MODULE_JRIDE MODULE_ADVANCED_ATA
+DEFINES_AT_LARGE = $(DEFINES_AT) MODULE_BOOT_MENU MODULE_JRIDE MODULE_ADVANCED_ATA
 
 DEFINES_JRIDE_8K = ELIMINATE_CGA_SNOW MODULE_JRIDE
-DEFINES_386_8K = USE_386 USE_AT MODULE_ADVANCED_ATA
+DEFINES_386_8K = USE_AT USE_386 MODULE_ADVANCED_ATA
 
 
